﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;

namespace MvcAjax
{
    public abstract class MvcAjaxControl : Control
    {
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            this.PageRequestManager = PageRequestManager.GetCurrent(this.Page);
        }

        internal PageRequestManager PageRequestManager
        {
            get;
            private set;
        }

        internal bool PageInitCompleted
        {
            get
            {
                return (this.PageRequestManager != null) && (this.PageRequestManager.PageInitCompleted);
            }
        }

        internal bool IsAjaxRequest
        {
            get
            {
                return MvcAjax.PageRequestManager.IsAjaxRequest(this.Context.Request);
            }
        }
    }
}
