﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace MvcAjax
{
    public class MvcAjaxPanel : MvcAjaxControl
    {
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            this.PageRequestManager.RegisterAjaxPanel(this);
        }

        public MvcAjaxPanelRenderMode RenderMode { get; set; }

        public string UpdateAreaID { get; set; }

        protected override void RenderChildren(HtmlTextWriter writer)
        {
            if (this.IsAjaxRequest)
            {
                base.RenderChildren(writer);
            }
            else
            {
                writer.AddAttribute(HtmlTextWriterAttribute.Id, this.ClientID);

                if (this.RenderMode == MvcAjaxPanelRenderMode.Block)
                {
                    writer.RenderBeginTag(HtmlTextWriterTag.Div);
                }
                else
                {
                    writer.RenderBeginTag(HtmlTextWriterTag.Span);
                }

                base.RenderChildren(writer);
                writer.RenderEndTag();
            }
        }
    }
}
