﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Web;

namespace MvcWebApp.Models
{
    public class Product
    {
        static Product()
        {
            string dataFile = HttpContext.Current.Server.MapPath("~/App_Data/Products.xml");
            Product.All = XElement.Load(dataFile).Elements("Product").Select(e => new Product
                          {
                              ProductID = (int)e.Attribute("ProductID"),
                              Name = (string)e.Attribute("Name"),
                              Price = (double)e.Attribute("Price"),
                              Category = (string)e.Attribute("Category")
                          }).ToList();
        }

        public static List<Product> All
        {
            get;
            private set;
        }

        public int ProductID { get; set; }

        public string Name { get; set; }

        public double Price { get; set; }

        public string Category { get; set; }
    }
}